(document:surround "/std/base")
(document:envelop with-translation _ "alterator-printers")

width 460
height 390
title (_ "Local connection setup")

(define (get-devices)
  (woo-catch
            (lambda()
              (woo-list-names "/printer_detect"))
            (lambda(reason) '())))


(define printer-devices (get-devices))

(set-global! 'printer-model (or (global 'printer-driver) (list "" "" "")))
(set-global! 'load-auto (make-cell #f))

(define printer-uri (make-cell (or (global 'printer-uri) "")))


(define (device name)
  (woo-read-first (string-append "/printer_detect/" name)))
  
(define (get-current)
  (list-index (lambda(x)
                (let* ((device (device x))
                       (uri (woo-get-option device 'uri)))
                  (string=? uri (cell-ref printer-uri))))
              printer-devices))

(define printer-current (get-current))

(document:id devicelist (listbox rows printer-devices
                                 layout-policy 100 20
				 header `#(,(_ "Devices"))
                                 (let ((printer-current (get-current)))
                                   (and printer-current
                                        (list current printer-current)))
                                 (when selected
                                   (let* ((device (device (devicelist text)))
                                          (driver (woo-get-option device 'driver #f))
                                          (driver-lst (and driver (string-cut driver #\;)))
                                          (uri (woo-get-option device 'uri)))
                                     (and driver
                                          (begin
                                            (set-global! 'printer-model
                                                         (list (car driver-lst)
                                                               (string-append (car driver-lst)
                                                                              " "
                                                                              (cadr driver-lst))))
                                            ((cell-ref (global 'load-auto)))))
                                     (cell-set! printer-uri uri)))))
(label "")                                        
(vbox layout-policy 100 -2 (document:subdocument '/printers/mdl))
(label "")

(hbox layout-policy 100 -1
      (document:id ok-button (button (_ "OK")
                                     (when clicked
                                       (document:end (cons (cell-ref printer-uri)
                                                           (global 'printer-model))))))
      (button (_ "Cancel") (when clicked (document:end #f))))
