(document:surround "/std/base")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-printers")

(define (cleanup-model-name vendor model)
  (and (not-empty-string? vendor)
       (not-empty-string? model)
       (let* ((cutted (substring model (string-length vendor)
                                 (string-length model)))
              (start (string-skip cutted #\space)))
         (substring cutted start (string-length cutted)))))

(define (on-load-error reason) '())

(define (get-vendors)
  (woo-catch
   (lambda()
     (sort (woo-list-names "/printer_drivers")
           string<?))
   on-load-error))

(define (get-models name)
  (woo-catch
   (lambda()
     (sort (woo-list-names (string-append "/printer_drivers/" name))
           string<?))
   on-load-error))

(define (auto-select auto-item lst)
  (and auto-item
       (string-list-index auto-item lst)))

(define (load-auto)
  (let* ((printer-model (global 'printer-model))
         (auto-vendor (cond-car printer-model))
         (auto-model (cleanup-model-name (cond-car printer-model)
                                         (cond-cadr printer-model)))
         (vendors (get-vendors))
         (auto-vendor-num (or (auto-select auto-vendor vendors) 0))
         (models (if (null? vendors)
                     '()
                     (get-models (list-ref vendors auto-vendor-num))))
         (auto-model-num (or (auto-select auto-model models) 0)))

    (vendorlist rows vendors
                current auto-vendor-num)
    (modellist rows models
               current auto-model-num)))

;;;;;;;;;;;;;;;;;;;;;;


(hbox layout-policy 100 -1
      (label (_ "Printer Model:"))
      (document:id vendorlist
                   (combobox layout-policy -2 -1

                             (when selected
                               (modellist rows (get-models (vendorlist text))
                                          current 0)
                               (set-car! (global 'printer-model) (vendorlist text))
                               ))))
(document:id modellist
             (listbox layout-policy 100 -2
                      header `#(,(_ "Model Name"))
                      (when selected
                        (set-car! (cdr (global 'printer-model)) (string-append
                                                        (vendorlist text)
                                                        " "
                                                        (modellist text))))))
;;;;;;;;;;;;;;;;;;;;;;;

(load-auto)
(and (global 'load-auto) (cell-set! (global 'load-auto) load-auto))
