(document:surround "/std/base")
(document:envelop with-translation _ "alterator-printers")

width 460
height 390
title (_ "Samba connection setup")

(set-global! 'printer-model (or (global 'printer-driver) (list "" "" "")))

(define (drop-header str)
  (and (string? str)
       (let ((size (string-length "smb://")))
         (or
          (and (string? str) (> (string-length str) size)
               (string-drop str size))
          ""))))


;;(define printer-model (make-cell (global 'printer-driver)))
(define printer-uri (drop-header (global 'printer-uri)))


(define (extract-user-password str)
  (and (not-empty-string? str)
       (let ((sep (string-index printer-uri #\@)))
         (and sep
              (string-cut (string-take str sep) #\:)))))

(define (extract-group-host-share str)
  (and (not-empty-string? str)
       (string-cut (string-drop str
                                (+ 1 (or (string-index printer-uri #\@) -1)))
                   #\/)))

(define (check-length lst)
  (if (and (pair? lst) (= (length lst)  2))
      (cons "" lst)
      lst))

(define smb-u-p (extract-user-password printer-uri))
(define smb-g-h-s (check-length (extract-group-host-share printer-uri)))

(define (not-empty-field? f)
  (not-empty-string? (f text)))

(define (allow-ok)
	(and (not-empty-field? smb-host)
             (not-empty-field? smb-share)
             (not-empty-field? smb-user)))

(define field-options (list (layout-policy 50 -1)
                            (when changed
                             (ok-button activity
			                (allow-ok)))))


(define (made-user-password)
  (string-join (delete ""
                       (list (smb-user text)
                             (smb-password text)))
               ":"))

(define (made-group-host-share)
  (string-join (delete ""
                       (list (smb-workgroup text)
                             (smb-host text)
                             (smb-share text)))
               "/"))

(define (made-uri)
  (string-append
   "smb://"
   (string-join (delete ""
                        (list (made-user-password)
                              (made-group-host-share)))
                        "@")))

(define (cond-caddr x)
  (and (pair? x)
       (pair? (cdr x))
       (pair? (cddr x))
       (caddr x)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(vbox layout-policy 100 -2
      (vbox layout-policy 100 -1
            (hbox layout-policy 100 -1
                  (label (_ "SMB server group:") layout-policy 50 -1)
                  (document:id smb-workgroup (edit (or (cond-car smb-g-h-s) "")
                                                   field-options)))
            (hbox layout-policy 100 -1
                  (label (_ "SMB server host:") layout-policy 50 -1)
                  (document:id smb-host (edit (or (cond-cadr smb-g-h-s) "")
                                              field-options)))
            (hbox layout-policy 100 -1
                  (label (_ "SMB share name:") layout-policy 50 -1)
                  (document:id smb-share (edit (or (cond-caddr smb-g-h-s) "")
                                               field-options)))
            (hbox layout-policy 100 -1
                  (label (_ "User name:") layout-policy 50 -1)
                  (document:id smb-user (edit (or (cond-car smb-u-p) "")
                                              field-options)))
            (hbox layout-policy 100 -1
                  (label (_ "Password:") layout-policy 50 -1)
                  (document:id smb-password (edit (or (cond-cadr smb-u-p) "")
                                                  field-options
                                                  echo stars ))))
        (label "")
        (vbox layout-policy 100 -2
	      (document:subdocument '/printers/mdl))
	(label ""))


(hbox layout-policy 100 -1
      (document:id ok-button (button (_ "OK" )
      				activity (and (not-empty-string? (cond-car smb-u-p))
				              (not-empty-string? (cond-cadr smb-g-h-s))
					      (not-empty-string? (cond-caddr smb-g-h-s)))
                                (when clicked
                                  (document:end (cons (made-uri) (global 'printer-model))))))
      (button (_ "Cancel") (when clicked (document:end #f))))
